<?php

  class pz_sqlite
  {
    public $link;

    private $path;
    private $file;

    function __construct($path, $file, $user = "", $password = "")
    { $this->path = $path.($path && substr($path, -1) != "/" ? "/" : "");
      $this->file = $file;
      if(!function_exists("sqlite_open")) throw new Exception
      ( $this->exception_out
        ( "L'extention php_sqlite ne semble pas etre installee"
        )
      );
    }

    function connect($path, $file, $user = "", $password = "")
    { $this->path = $path.($path && substr($path, -1) != "/" ? "/" : "");
      $this->file = $file;
      $this->link = @sqlite_open($this->path.$this->file, 0666, $sqliteerror);
      if(!$this->link) throw new Exception
      ( $this->exception_out
        ( "Impossible d'ouvrir le fichier de la base. verifiez qu'un fichier "
         .$this->path.$this->file." existe est qu'il est accessible en &eacute;criture."
        )
      );
    }

    function select_db($file)
    { $this->close();
      $this->connet($this->path, $file);
    }

    function desc($table_name)
    { $rst = $this->query("DESC ".$table_name);
      $TABLE = Array();
      while($v_rst = sqlite_fetch_array($rst))
      { $TABLE[$v_rst["Field"]] = Array();
        $TABLE[$v_rst["Field"]]["Type"] = $v_rst["Type"];
        if(strlen($v_rst["Type"]) >=4 && strcmp(substr($v_rst["Type"], 0, 4), "enum") == 0)
        { $TABLE[$v_rst["Field"]]["Enum"] = Array();
          $enum_values = substr($v_rst["Type"], 5, -1);
          $v_enum_values = explode(',', $enum_values);
          foreach($v_enum_values as $enum_value)
          { $TABLE[$v_rst["Field"]]["Enum"][] = trim($enum_value, "'");
          }
        }
      }
      return $TABLE;
    }

    function table_exists($file, $table)
    { $this->select_db($file);
      $rst = $this->query("SHOW TABLES");
      while($v_rst = sqlite_fetch_array($rst))
      { if(strcmp($v_rst[0], $table) == 0) return true;
      }
      return false;
    }

    function base_exists($file)
    { return false;
    }

    function query($query_string)
    { if(!$this->link) $this->connect($this->path, $this->file);
      $result = @sqlite_query($this->link, str_replace("`", "", $query_string));
      if(!$result) throw new Exception($this->exception_out("Syntaxe invalide dans une requete"));
      return $result;
    }

    function fetch_assoc($rst)
    { if($this->link)
      { $row = @sqlite_fetch_array($rst, SQLITE_ASSOC);
        if($row) foreach($row as $key => $value)
        { if(!preg_match("/^[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*$/", $key)) unset($row[$key]);
        }
        return $row;
      }
      throw new Exception($this->exception_out("Erreur fetch_assoc"));
    }

    function insert_id()
    { if($this->link) return @sqlite_last_insert_rowid($this->link);
      throw new Exception($this->exception_out("Erreur insert_id"));
    }

    function free_result($rst)
    {
    }

    function db_size()
    { $rst = $this->query("SHOW TABLE STATUS");
      $size = 0;
      while($v_rst = $this->fetch_assoc($rst)) $size += $v_rst["Data_length"] + $v_rst["Index_length"];
      return $size;
    }

    function close() { if($this->link) sqlite_close($this->link); }

    function exception_out($message)
    { return "  [erreur] sqlite : ".$message."\n";
    }

  }

?>