<?php

  class pz_env_out extends pz_env
  {

    function out_file_exists($file)
    { return
      ( $this->config("out") ?
          file_exists($this->path("out").$this->config("out").$file) ||
          file_exists($this->path("out").$this->path("dist_out").$file)
        : file_exists($this->path("out").$this->path("current_out").$file) ||
          file_exists($this->path("out").$this->path("dist_out").$file)
      );
    }

    function out_file($file)
    { return
      ( $this->config("out") ?
          ( file_exists($this->path("out").$this->config("out").$file) ?
              $this->path("out").$this->config("out").$file
            : (file_exists($this->path("out").$this->path("dist_out").$file) ? $this->path("out").$this->path("dist_out").$file : $file)
          )
        : ( file_exists($this->path("out").$this->path("current_out").$file) ?
              $this->path("out").$this->path("current_out").$file
            : (file_exists($this->path("out").$this->path("dist_out").$file) ? $this->path("out").$this->path("dist_out").$file : $file)
          )
      );
    }

    function out_pathes()
    { $pathes = array();
      if($dh = opendir($this->path("out")))
      { while(($file = readdir($dh)) !== false)
        { if(is_dir($this->path("out").$file) && substr($file, 0 ,1) != ".") $pathes[] = $file;
        }
        closedir($dh);
      }
      else $pathes = false;
      return $pathes;
    }

    function get_empty_layout() { return "<"."?xml version=\"1.0\" encoding=\"UTF-8\"?"."><pz_layout />"; }

    function init_layout()
    { $this->env->layout = simplexml_load_string($this->get_empty_layout());
      if($this->out_file_exists("layouts/index.xml"))
      { $this->load_layout($this->out_file("layouts/index.xml"));
      }
      if($this->etat("mod") != "index" && $this->out_file_exists("layouts/".$this->etat("mod").".xml"))
      { $this->load_layout($this->out_file("layouts/".$this->etat("mod").".xml"));
      }
      return $this->get_layout();
    }

    function load_layout($layout_file)
    { if(file_exists($layout_file))
      { libxml_use_internal_errors(true);
        if($layout = simplexml_load_file($layout_file))
        { $this->_load_layout($layout, $this->env->layout, "pz_layout");
          return true;
        }
        else
        { foreach(libxml_get_errors() as $error)
          { //debug($error);
          }
          libxml_clear_errors();
        }
      }
      return false;
    }

    function _load_layout($src, $dest, $elt_name)
    { eval("\$IS_SET = isset(\$dest->".$elt_name.");");
      if(!$IS_SET) $dest->addChild($elt_name);
      if(isset($src["page"]))
      { eval("\$IS_SET = isset(\$dest->".$elt_name."[\"page\"]);");
        if(!$IS_SET) $dest->$elt_name->addAttribute("page", "not_set");
        eval("\$dest->".$elt_name."[\"page\"] = (string)\$src[\"page\"];");
      }
      if(isset($src["content"]))
      { eval("\$IS_SET = isset(\$dest->".$elt_name."[\"content\"]);");
        if(!$IS_SET) $dest->$elt_name->addAttribute("content", "not_set");
        eval("\$dest->".$elt_name."[\"content\"] = (string)\$src[\"content\"];");
      }
      foreach($src as $sub_elt_name => $sub_src)
      { $this->_load_layout($sub_src, $dest->$elt_name, $sub_elt_name);
      }
    }

    function get_layout()
    { $mod = $this->etat("mod");
      $controller = $this->etat("controller");
      $action = $this->etat("action");
      eval("\$content = (string)\$this->env->layout->pz_layout->".$mod."->".$controller."->".$action."[\"content\"];");
      if(!$content)
      { eval("\$content = (string)\$this->env->layout->pz_layout->".$mod."->".$controller."[\"content\"];");
        if(!$content)
        { eval("\$content = (string)\$this->env->layout->pz_layout->".$mod."[\"content\"];");
          if(!$content)
          { eval("\$content = (string)\$this->env->layout->pz_layout->index[\"content\"];");
          }
        }
      }
      eval("\$page = (string)\$this->env->layout->pz_layout->".$mod."->".$controller."->".$action."[\"page\"];");
      if(!$page)
      { eval("\$page = (string)\$this->env->layout->pz_layout->".$mod."->".$controller."[\"page\"];");
        if(!$page)
        { eval("\$page = (string)\$this->env->layout->pz_layout->".$mod."[\"page\"];");
          if(!$page)
          { eval("\$page = (string)\$this->env->layout->pz_layout->index[\"page\"];");
          }
        }
      }
      return array
      ( "page" => $page,
        "content" => $content
      );
    }

    function render_layout($layout = null)
    { $this->out = $this->env->out;
      $this->user = $this->env->user;
      $this->data = $this->env->data;
      if(!isset($layout)) $layout = $this->init_layout();
      if(file_exists($this->path("out").$this->path("current_out")."functions.php"))
      { require $this->path("out").$this->path("current_out")."functions.php";
      }
      if($this->path("current_out") != $this->path("dist_out") && file_exists($this->path("out").$this->path("dist_out")."functions.php"))
      { require $this->path("out").$this->path("dist_out")."functions.php";
      }
      if($layout["page"])
      { if($this->out_file_exists($layout["page"])) require $this->out_file($layout["page"]);
      }
      elseif($layout["content"])
      { if($this->out_file_exists($layout["content"])) require $this->out_file($layout["content"]);
      }
    }

  }

?>